package domhues.prototypes.examples;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Map.Entry;

import miselico.prototypes.knowledgebase.AddChangeSet;
import miselico.prototypes.knowledgebase.Property;
import miselico.prototypes.knowledgebase.PrototypeDefinition;
import miselico.prototypes.knowledgebase.RemoveChangeSet;

import org.apache.abdera.i18n.iri.IRISyntaxException;
import org.apache.brooklyn.util.collections.MutableMap;

import com.google.common.collect.ImmutableMap;

import domhues.prototypes.expressions.IncomingChangeExpression;
import domhues.prototypes.expressions.IncomingPrototypeExpression;
import domhues.prototypes.links.ID;

public class FileGenerator {

  public static void main(String[] args) throws IOException {
    generateRandomKB(100, true, true, true);
    generateBlockKB(1,true,true);
    generateBaselineKB(4,true,true);
    generateProplineKB(4,true,true);
    
  }


  /**
   * Generate a random(amount) file according to the description of the thesis
   * @param amount
   * @param randomMutability
   * @param shuffle
   * @param properties
   * @return
   * @throws IOException 
   */
  public static File generateRandomKB(int amount, boolean randomMutability, boolean shuffle, boolean properties) throws IOException {
    ArrayList<IncomingPrototypeExpression> list = new ArrayList<IncomingPrototypeExpression>();
    int random1 = 0;
    IncomingPrototypeExpression.Builder incProto;
    // Add first one
    list.add((new IncomingPrototypeExpression.Builder(generateID(0), new IncomingChangeExpression(ID.of("proto:null"), ID.of("proto:P_0"), false))).build());

    for (int i = 1; i < amount; i++) {
      random1 = (int) (Math.random() * (i - 1));
      if ((int) (Math.random() * 100) < 80 || !randomMutability) {
        incProto = new IncomingPrototypeExpression.Builder(generateID(i), new IncomingChangeExpression(ID.of("proto:null"), generateID(random1), false));
      } else {
        incProto = new IncomingPrototypeExpression.Builder(generateID(i), new IncomingChangeExpression(ID.of("proto:null"), generateID(random1), true));
      }
      // add up to 10 properties to the add or remove set
      if (properties) {
        incProto = addProperties(incProto, randomMutability);
        incProto = remProperties(incProto, randomMutability);
      }
      list.add(incProto.build());
    }
    
    // add the properties to the data set.
    if(properties){
      list = addPropertiesToList(list);
    }
    
    // shuffle the data set
    if (shuffle) {
      list = durstenfeldShuffle(list);
    }
    
    // create the file
    File f = new File("randomKB.proto");
    f.createNewFile();
    return getFileFromPrototypeList(list, f, false);
  }

  /**
   * Creates a baseline set generated by miselico and converted to the needed input format.
   * @param amount
   * @param randomMutability
   * @param shuffle
   * @return
   * @throws IRISyntaxException
   * @throws IOException
   */
  public static File generateBlockKB(int amount, boolean randomMutability, boolean shuffle) throws IRISyntaxException, IOException{
    
    // replace self property loop in file
    MutableMap.Builder<miselico.prototypes.knowledgebase.ID, PrototypeDefinition> map = new MutableMap.Builder<miselico.prototypes.knowledgebase.ID, PrototypeDefinition>().putAll(Datasets.blocks(amount).build().KB);
    map.remove(miselico.prototypes.knowledgebase.ID.of("http://www.example.com#object0_0"));
    map.put(miselico.prototypes.knowledgebase.ID.of("http://www.example.com#object0_0"), 
            PrototypeDefinition.create(miselico.prototypes.knowledgebase.Prototype.P_0,
                RemoveChangeSet.builder().build(),
                AddChangeSet.builder().build()));
    
    
    
    ArrayList<IncomingPrototypeExpression> pe = mapPrototypes(ImmutableMap.copyOf(map.build()), randomMutability, false);
    if(shuffle){
      pe = durstenfeldShuffle(pe);
    }
    File f = new File("blocks.proto");
    f.createNewFile();
    return getFileFromPrototypeList(pe, f, false);
  }
  
  /**
   * Creates a baseline set generated by miselico and converted to the needed input format.
   * @param amount
   * @param randomMutability
   * @param shuffle
   * @return
   * @throws IRISyntaxException
   * @throws IOException
   */
  public static File generateBaselineKB(int amount, boolean randomMutability, boolean shuffle) throws IRISyntaxException, IOException{
    ArrayList<IncomingPrototypeExpression> pe = mapPrototypes(Datasets.baseline(amount).build().KB, randomMutability, false);
    if(shuffle){
      pe = durstenfeldShuffle(pe);
    }
    File f = new File("baseline.proto");
    f.createNewFile();
    return getFileFromPrototypeList(pe, f, false);
  }
  
  /**
   * Creates a propline set according to the thesis based on miselico baseline data and converted to the needed input format.
   * @param amount
   * @param randomMutability
   * @param shuffle
   * @return
   * @throws IRISyntaxException
   * @throws IOException
   */
  public static File generateProplineKB(int amount, boolean randomMutability, boolean shuffle) throws IRISyntaxException, IOException{
    ArrayList<IncomingPrototypeExpression> pe = mapPrototypes(Datasets.baseline(amount).build().KB, randomMutability, true);
    if(shuffle){
      pe = durstenfeldShuffle(pe);
    }
    File f = new File("propline.proto");
    f.createNewFile();
    return getFileFromPrototypeList(pe, f, false);
  }
  
  
  /**
   * Implementation of the Durstenfeld Shuffle ( A modern version of Fisher–Yates shuffle)
   * 
   * @param list
   * @return shuffled list
   */
  private static ArrayList<IncomingPrototypeExpression> durstenfeldShuffle(ArrayList<IncomingPrototypeExpression> list) {
    int random = 0;
    IncomingPrototypeExpression tmp;
    for (int i = list.size() - 1; i > 0; i--) {
      random = (int) (Math.random() * i);
      tmp = list.get(i);
      list.set(i, list.get(random));
      list.set(random, tmp);
    }
    return list;
  }

  /**
   * Creates a File of Prototype Expressions from a given List of Incoming Prototype Expressions.
   * @param list
   * @param pF
   * @return File 
   */
  private static File getFileFromPrototypeList(ArrayList<IncomingPrototypeExpression> list, File pF, boolean showStats) {
    int mutableLinks = 0;
    int immutableLinks = 0;
    int mutableBaseLinks = 0;
    int immutableBaseLinks = 0;
    try {

      pF.createNewFile();
      PrintWriter writer = new PrintWriter(new FileWriter(pF));
      for (IncomingPrototypeExpression incProto : list) {
        writer.println("ID:");
        writer.println(incProto.getIdAsString());
        writer.println("BASE:");
        if (incProto.hasMutableBase()) {
          mutableBaseLinks++;
          writer.println(incProto.getBase() + " -mutable");
        } else {
          immutableBaseLinks++;
          writer.println(incProto.getBase());
        }
        writer.println("ADD:");
        for (IncomingChangeExpression prop : incProto.getAddList()) {
          if (prop.isMutable()) {
            mutableLinks++;
            writer.println(prop.getName() + " " + prop.getLink() + " -mutable");
          } else {
            immutableLinks++;
            writer.println(prop.getName() + " " + prop.getLink());
          }
        }
        writer.println("REMOVE:");
        for (IncomingChangeExpression prop : incProto.getRemoveList()) {
          if (prop.isMutable()) {
            mutableLinks++;
            writer.println(prop.getName() + " " + prop.getLink() + " -mutable");
          } else {
            immutableLinks++;
            writer.println(prop.getName() + " " + prop.getLink());
          }
        }
        writer.println("");

      }
      writer.close();
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }

    if(showStats){
      System.out.println("Total Count: " + (mutableBaseLinks + immutableBaseLinks));
      System.out.println("Immutable base links: " + immutableBaseLinks);
      System.out.println("Mutable base links: " + (mutableBaseLinks));
      System.out.println("Immutable links: " + immutableLinks);
      System.out.println("Mutable links: " + (mutableLinks));
      System.out.println(pF.toString());
    }
    return pF;
  }

  /**
   * By Michael Cochez
   * 
   * @param i
   * @return
   * @throws IOException 
   * @throws IRISyntaxException 
   */
  private static ID generateID(int i) throws IRISyntaxException, IOException {
    return ID.of("http://www.example.com#object" + i);
  }
   
 /**
  * Converts a ImmutableMap of Prototype expressions (from miselico.knowledgebase) into a List of Incoming Prototype Expressions as used in this project.
  * @param source
  * @param randomMutability
  * @return
  * @throws IRISyntaxException
  * @throws IOException
  */
  private static ArrayList<IncomingPrototypeExpression> mapPrototypes(ImmutableMap<miselico.prototypes.knowledgebase.ID, miselico.prototypes.knowledgebase.PrototypeDefinition> source, boolean randomMutability, boolean properties) throws IRISyntaxException, IOException{
    ArrayList<IncomingPrototypeExpression> target = new ArrayList<IncomingPrototypeExpression>();
    IncomingPrototypeExpression.Builder incProt;
    IncomingChangeExpression base;
    for(Entry<miselico.prototypes.knowledgebase.ID, PrototypeDefinition> entry : source.entrySet()){
      
      //convert base and ID. No mutable link to P_0
      if(entry.getValue().parent.toString().equals("proto:P_0")){
        base = new IncomingChangeExpression(ID.of("proto:null"),ID.of(entry.getValue().parent.toString()),false);
      }else{
        base = new IncomingChangeExpression(ID.of("proto:null"),ID.of(entry.getValue().parent.toString()),randomMutablity(randomMutability));
      }
      incProt = new IncomingPrototypeExpression.Builder(ID.of(entry.getKey().toString()), base);  
      
      //convert removes
      for(Entry<Property, miselico.prototypes.knowledgebase.ID> rem : entry.getValue().remove.entries()){
        incProt.remove(ID.of(rem.getKey().getValue().toString()), ID.of(rem.getValue().toString()), randomMutablity(randomMutability));
      }
      if(properties){
        incProt = remProperties(incProt, randomMutability);
      }
      
      //convert adds
      for(Entry<Property, miselico.prototypes.knowledgebase.ID> add : entry.getValue().add.entries()){
        incProt.add(ID.of(add.getKey().getValue().toString()), ID.of(add.getValue().toString()), randomMutablity(randomMutability));
      }
      if(properties){
        incProt = addProperties(incProt, randomMutability);
      }
      
      //Add Prototype Expression to List.
      target.add(incProt.build());
    }
    
    // add properties to data set if needed.
    if(properties){
      target = addPropertiesToList(target);
    }
    
    
    return target;
  }
  
  /**
   * Returns true with a chance of 20%. If randomMutablity is false then it will always return false
   * @param randomMutability
   * @return
   */
  private static boolean randomMutablity(boolean randomMutability){
    int random = (int) (Math.random() * 100);
    if (random < 80 || !randomMutability) {
      return false;
    }else{
      return true;
    }
  }
    
  /**
   * Adds up to 10 properties to the prototype expressions add set
   * @param incProt
   * @param randomMutability
   * @return
   * @throws IRISyntaxException
   * @throws IOException
   */
  private static IncomingPrototypeExpression.Builder addProperties(IncomingPrototypeExpression.Builder incProt, boolean randomMutability) throws IRISyntaxException, IOException{
    int randomAmount = (int) (Math.random() * 10);
    int randomProp = (int) (Math.random() * 19);
    for (int i = 0; i<randomAmount; i++){
      incProt.add(ID.of("http://www.example.com#prop_name"+randomProp), ID.of("http://www.example.com#prop"+randomProp), randomMutablity(randomMutability));     
      randomProp = (int) (Math.random() * 19);
    }
    return incProt;
  }
  
  /**
   * Adds up to 10 properties to the prototype expressions remove set
   * @param incProt
   * @param randomMutability
   * @return
   * @throws IRISyntaxException
   * @throws IOException
   */
  private static IncomingPrototypeExpression.Builder remProperties(IncomingPrototypeExpression.Builder incProt, boolean randomMutability) throws IRISyntaxException, IOException{
    int randomAmount = (int) (Math.random() * 10);
    int randomProp = (int) (Math.random() * 19);
    for (int i = 0; i<randomAmount; i++){
      incProt.remove(ID.of("http://www.example.com#prop_name"+randomProp), ID.of("http://www.example.com#prop"+randomProp), randomMutablity(randomMutability));   
      randomProp = (int) (Math.random() * 19);
    }
    return incProt;
  }
  
  /**
   * Adds the properties to the set of prototype expressions.
   * @param target
   * @return
   * @throws IRISyntaxException
   * @throws IOException
   */
  private static ArrayList<IncomingPrototypeExpression> addPropertiesToList(ArrayList<IncomingPrototypeExpression> target) throws IRISyntaxException, IOException{
    IncomingPrototypeExpression.Builder incProt;
    for(int i = 0; i<20; i++){
      incProt = new IncomingPrototypeExpression.Builder(ID.of("http://www.example.com#prop"+i), new IncomingChangeExpression(ID.of("proto:null"), ID.of("proto:P_0"), false));
      target.add(incProt.build());
    }
    return target;
  }
 

}
